package myPackage;

import myPackage.objects.ContextItem;

import javax.naming.NamingException;
import javax.naming.directory.Attribute;

import metrohm.intranet.utils.Formatter.Formatter;
import metrohm.intranet.utils.Formatter.TimestampConverter;
import metrohm.intranet.utils.Calendar.ScrollCalendar;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.GregorianCalendar;

/**
 * Created by IntelliJ IDEA.
 * User: ls
 * Date: 25.01.2006
 * Time: 19:00:58
 * To change this template use File | Settings | File Templates.
 */
public class InfoPoint
{
    private Ldap ldap;


    public static void main(String[] args)
    {
        InfoPoint main = null;

        try
        {
            main = new InfoPoint();

            ArrayList data = main.search(10);

            if (data != null)
            {
                Iterator it = data.iterator();
                while (it.hasNext())
                {
                    String[] array = (String[])it.next();

                    String name = array[0];
                    String birthday = array[1];

                    System.out.println(name + " / " + birthday);
                }
            }
        }
        catch (Exception e)
        {
            e.printStackTrace();
        }
        finally
        {
            main.close();
        }
    }

    public InfoPoint() throws NamingException
    {
        ldap = new Ldap();
    }

    public void close()
    {
        ldap.close();
    }

    public ArrayList search(int days) throws Exception
    {
        ContextItem[] items = ldap.search(new String[] {"birthday", "displayName"}, "", "officePerson", false);

        if (items != null)
        {
            // Objekte initialisieren
            Formatter format = new Formatter();
            TimestampConverter timestamp = new TimestampConverter();
            ScrollCalendar cal = new ScrollCalendar();


            // aktuelles Jahr und Vergleichszeit als Timestamp
            int currentyear = format.getCurrentYear();
            long currentTimestamp = timestamp.getCurrentTimestamp();
            for (int i = 0; i < days; i++)
            {
                cal.nextDay();
            }
            String timestampCal = cal.getDate(cal.getCalendar());
            long timestampDays = timestamp.formatDateStringToTimestamp(timestampCal);


            // sammelt Personen, welche innerhalb des Intervalls Geburtstag haben
            ArrayList data = new ArrayList();

            for (int i = 0; i < items.length; i++)
            {
                ContextItem item = items[i];

                // Attribute auslesen
                Attribute[] attrs = item.getAttributes();

                String name = null;
                String birthday = null;

                // Geburtstag und Name bestimmen
                for (int j = 0; j < attrs.length; j++)
                {
                    Attribute attr = attrs[j];

                    String id = attr.getID();
                    String value = (String)ldap.getAttributeValue(attr);

                    if (id.equals("displayName"))
                        name = value;
                    else if (id.equals("birthday"))
                        birthday = value;
                }

                // Geburtstag vergleichen
                if (name != null && birthday != null)
                {
                    // Jahr ersetzen
                    String temp = birthday.substring(0, 6);
                    temp = temp + currentyear;

                    // in Timestamp umwandeln
                    long birthday_timestamp = timestamp.formatDateStringToTimestamp(temp);

                    // prfen, ob Timestamp im Intervall liegt
                    if (currentTimestamp <= birthday_timestamp && birthday_timestamp <= timestampDays)
                    {
                        String[] array = {name, birthday};
                        data.add(array);
                    }
                }
            }

            return data;
        }

        return null;
    }
}
